#version 430

#define MAX_POINTS (1500000)

layout(early_fragment_tests) in;

layout(r32ui, binding = 0) uniform uimage2D u_multimap;
layout(r32ui, binding = 1) uniform uimage2D u_pixelsinshadow;

layout(std430, binding = 0) buffer Elements {
	uint ElNextFree;
	
	uint ElNexts[MAX_POINTS];
	vec3 ElPoints[MAX_POINTS];
	uint ElFBCoords[MAX_POINTS];
};

uniform mat4 u_lightvp;

varying vec3 v_posworld;

void main() {
	imageStore(u_pixelsinshadow, ivec2(gl_FragCoord.xy), uvec4(0, 0, 0, 0));
	
	vec4 projected = u_lightvp * vec4(v_posworld, 1);
	
	projected /= projected.w;
	
	if(projected.x >= -1.0 && projected.x <= 1.0 && projected.y >= -1.0 && projected.y <= 1.0 && projected.z >= -1.0 && projected.z <= 1.0) {
		uint idx = atomicAdd(ElNextFree, 1);
		
		if(idx < MAX_POINTS) {
			ivec2 imgCoord = ivec2((projected.xy * 0.5 + 0.5) * imageSize(u_multimap));
			
			ElNexts[idx] = imageAtomicExchange(u_multimap, imgCoord, idx);
			ElPoints[idx] = projected.xyz;
			ElFBCoords[idx] = (uint(gl_FragCoord.x) << 16) + uint(gl_FragCoord.y);
		}
	}
}
