#version 430

layout(triangles) in;
layout(triangle_strip, max_vertices = 3) out;

layout(r32ui, binding = 0) uniform uimage2D u_multimap;

out vec4 v_gvertex0;
out vec4 v_gvertex1;
out vec4 v_gvertex2;

void main() {
	/*vec4 vsProjs[3] = vec4[3] (gl_in[0].gl_Position, gl_in[1].gl_Position, gl_in[2].gl_Position);
	vec3 normal = cross(vsProjs[1].xyz - vsProjs[0].xyz, vsProjs[0].xyz - vsProjs[2].xyz);
	
	float d = dot(vsProjs[0].xyz, normal);
	float normalSign = (normal.z > 0) ? 1.0 : -1.0;
	
	vec3 planes[3]; vec3 intersection[3]; float z[3];
	vec2 halfPixelSize = vec2(4 / imageSize(u_multimap).x);
	planes[0] = cross(vsProjs[0].xyw - vsProjs[2].xyw, vsProjs[2].xyw);
	planes[1] = cross(vsProjs[1].xyw - vsProjs[0].xyw, vsProjs[0].xyw);
	planes[2] = cross(vsProjs[2].xyw - vsProjs[1].xyw, vsProjs[1].xyw);
	planes[0].z += normalSign * dot(halfPixelSize, abs(planes[0].xy));
	planes[1].z += normalSign * dot(halfPixelSize, abs(planes[1].xy));
	planes[2].z += normalSign * dot(halfPixelSize, abs(planes[2].xy));
	intersection[0] = cross(planes[0], planes[1]);
	intersection[1] = cross(planes[1], planes[2]);
	intersection[2] = cross(planes[2], planes[0]);
	intersection[0] /= intersection[0].z;
	intersection[1] /= intersection[1].z;
	intersection[2] /= intersection[2].z;
	z[0] = (-intersection[0].x * normal.x - intersection[0].y * normal.y + d) / normal.z;
	z[1] = (-intersection[1].x * normal.x - intersection[1].y * normal.y + d) / normal.z;
	z[2] = (-intersection[2].x * normal.x - intersection[2].y * normal.y + d) / normal.z;
	vsProjs[0].xyz = vec3(intersection[0].xy, z[0]);
	vsProjs[1].xyz = vec3(intersection[1].xy, z[1]);
	vsProjs[2].xyz = vec3(intersection[2].xy, z[2]);
	
	for(int i = 0; i < 3; i++) {
		v_gvertex0 = gl_in[0].gl_Position / gl_in[0].gl_Position.w;
		v_gvertex1 = gl_in[1].gl_Position / gl_in[1].gl_Position.w;
		v_gvertex2 = gl_in[2].gl_Position / gl_in[2].gl_Position.w;
		
		gl_Position = vsProjs[i];
		//gl_Position = gl_in[i].gl_Position;
		
		EmitVertex();
	}*/
	
	/*vec4 vertex[3];
	for(int i = 0; i < gl_in.length(); i++) {
		vertex[i] = gl_in[i].gl_Position;
	}
	
	vec3 plane[3];
	for(int i = 0; i < gl_in.length(); i++) {
		plane[i] = cross(vertex[i].xyw, vertex[(i + 2) % 3].xyw);
		plane[i].z -= dot(vec2(0.0 / imageSize(u_multimap).x), abs(plane[i].xy));
	}
	
	for(int i = 0; i < gl_in.length(); i++) {
		vec3 intersect = cross(plane[i], plane[(i+1) % 3]);
	
		gl_Position.xyw = intersect;
		gl_Position.z = gl_in[i].gl_Position.z;
		
		//gl_Position = gl_in[i].gl_Position;

		v_gvertex0 = gl_in[0].gl_Position / gl_in[0].gl_Position.w;
		v_gvertex1 = gl_in[1].gl_Position / gl_in[1].gl_Position.w;
		v_gvertex2 = gl_in[2].gl_Position / gl_in[2].gl_Position.w;

		EmitVertex();
	}*/
	
	vec4 gs_out[3];
	gs_out[0] = gl_in[0].gl_Position;
	gs_out[1] = gl_in[1].gl_Position;
	gs_out[2] = gl_in[2].gl_Position;
	
	vec2 side0N = normalize(gs_out[1].xy - gs_out[0].xy);
	vec2 side1N = normalize(gs_out[2].xy - gs_out[1].xy);
	vec2 side2N = normalize(gs_out[0].xy - gs_out[2].xy);
	
	const float texel_size = 2 / float(imageSize(u_multimap).x);
	
	gs_out[0].xy += normalize(-side0N + side2N) * texel_size;
	gs_out[1].xy += normalize(side0N - side1N)  * texel_size;
	gs_out[2].xy += normalize(side1N - side2N)  * texel_size;
	
	for(int i = 0; i < 3; i++) {
		gl_Position = gs_out[i];
		v_gvertex0 = gl_in[0].gl_Position / gl_in[0].gl_Position.w;
		v_gvertex1 = gl_in[1].gl_Position / gl_in[1].gl_Position.w;
		v_gvertex2 = gl_in[2].gl_Position / gl_in[2].gl_Position.w;
		EmitVertex();
	}
	
	EndPrimitive();
}

/*layout(triangles) in;
layout(triangle_strip, max_vertices = 3) out;

layout(r32ui, binding = 0) uniform uimage2D u_multimap;

out vec4 v_gvertex0;
out vec4 v_gvertex1;
out vec4 v_gvertex2;

void main() {
	vec4 vertex[3];
	for(int i = 0; i < gl_in.length(); i++) {
		vertex[i] = gl_in[i].gl_Position;
	}
	
	vec3 plane[3];
	for(int i = 0; i < gl_in.length(); i++) {
		plane[i] = cross(vertex[i].xyw, vertex[(i + 2) % 3].xyw);
		plane[i].z -= dot(vec2(4.0 / imageSize(u_multimap).x), abs(plane[i].xy));
	}
	
	for(int i = 0; i < gl_in.length(); i++) {
		vec3 intersect = cross(plane[i], plane[(i+1) % 3]);
	
		gl_Position.xyw = intersect;
		gl_Position.z = gl_in[i].gl_Position.z;
		
		gl_Position = gl_in[i].gl_Position;

		v_gvertex0 = gl_in[0].gl_Position / gl_in[0].gl_Position.w;
		v_gvertex1 = gl_in[1].gl_Position / gl_in[1].gl_Position.w;
		v_gvertex2 = gl_in[2].gl_Position / gl_in[2].gl_Position.w;

		EmitVertex();
	}
	
	EndPrimitive();
}
*/

/*#version 430

#define M_PI 3.1415926535897932384626433832795

#define dilation 4

layout (triangles) in;
layout (triangle_strip, max_vertices = 9) out;

layout(r32ui, binding = 0) uniform uimage2D u_multimap;

out vec4 v_gvertex0;
out vec4 v_gvertex1;
out vec4 v_gvertex2;

float atan2(float y, float x) {
	bool s = (abs(x) > abs(y));
	return mix(M_PI / 2.0 - atan(x, y), atan(y, x), s);
}

void emit(vec4 position, int i) {
	v_gvertex0 = gl_in[0].gl_Position / gl_in[0].gl_Position.w;
	v_gvertex1 = gl_in[1].gl_Position / gl_in[1].gl_Position.w;
	v_gvertex2 = gl_in[2].gl_Position / gl_in[2].gl_Position.w;
	
	gl_Position = position;
	
	EmitVertex();
}

void main() {
	float hPixel = (1.0 / imageSize(u_multimap).x) * dilation;
	
	vec4 vertices[3];
	
	for(int i = 0; i < 3; i++) {
		int i0 = i, i1 = (i + 1) % 3, i2 = (i + 2) % 3;
		
		vec4 lp0 = gl_in[i0].gl_Position;
		vec4 lp1 = gl_in[i1].gl_Position;
		vec4 lp2 = gl_in[i2].gl_Position;
		
		vec2 v0 = normalize(lp0.xy - lp1.xy);
		vec2 v1 = normalize(lp2.xy - lp1.xy);
		
		vec2 mixed = -normalize((v0 + v1) / 2.f);
		
		float angle = atan2(v0.y, v0.x) - atan2(mixed.y, mixed.x);
		
		float vlength = abs(hPixel / sin(angle));
		
		vec2 offs = mixed * vec2(vlength);
		
		vertices[i1] = vec4(lp1.xy + offs, 0, 1);
	}

	emit(gl_in[0].gl_Position, 0);  // 0
	emit(gl_in[1].gl_Position, 1);  // 1
	emit(gl_in[2].gl_Position, 2);  // 2

	emit(vertices[2], 2);           // 3
	emit(gl_in[0].gl_Position, 0);  // 4
	emit(vertices[0], 0);           // 5
	
	emit(gl_in[1].gl_Position, 1);  // 6
	emit(vertices[1], 1);           // 7
	emit(vertices[2], 2);           // 8
}
*/
